
#ifndef __OSINLINE__
#define __OSINLINE__

/* What goes herein depends heavily on the OS. */

/*long long smull(int x, int y)
{
	int res_hi, res_lo;
	__asm { SMULL (&res_hi, &res_lo, x, y}
	return res_hi;

}*/

#define vec_mult _vec_mult
inline int _vec_mult(int x, int y) 
{  
	int res_hi, res_lo;
 	__asm
 	{
 		SMULL res_hi, res_lo, x, y
 	}
 	return res_hi;
}

/*#define vec_mult _vec_mult
asm int _vec_mult(int x, int y) 
{  
MUL R2,R1,R0
MOV R0,R2
BX LR 
}*/

//GCC version
/*#define vec_mult _vec_mult
INLINE int _vec_mult(int x, int y)
{
int res_hi, res_lo;

__asm__ __volatile__
("smull\t%1,%0,%2,%3"
: "=r"(res_hi), "=r"(res_lo)
: "r"(x), "r"(y)
);

return res_hi;
}
*/
#endif /* __OSINLINE__ */
