/**
 * BGM/SE manager header file.
 *
 * @version $Revision: 1.1.1.1 $
 */
 
#include <PalmOS.h>
 
#ifdef __cplusplus
extern "C" {
#endif

void closeSound();
void initSound();
Boolean playMusic(char *SongName);
void fadeMusic();
void stopMusic();
void playChunk(int idx);
void playRandomMusic();

extern int useAudio;

extern long MikMod_flags;
extern unsigned long *MikMod_audio_buf;
extern unsigned long MikMod_game_rom;

#define __PALM__


// bridge options going into the pno
#define BF_FULLSCREEN 1
#define BF_AUDIO      2
#define BF_LOWMEM     4
#define BF_ZODIAC     8
#define BF_HIRESPLUS  16
#define BF_PLAYMOD    16
#define BF_STOPMOD    32
#define BF_INITMOD    64
#define BF_FREEMOD    128
#ifdef __cplusplus
} // extern "C"
#endif